/*
  Demo
  Version: 0.5
  Author:  P. Peters
  Date:    October 13, 2016

  This example code is in the public domain.

*/

// use serial communication library
import processing.serial.*;

// linefeed character identifies end of line
byte linefeed = 10;
// define serial port
Serial myPort;
// define array to hold data (you need to know how many elements...)
int[] data = {0, 0, 0};

void setup() { 
  size(600, 300);
  //println(Serial.list());
  myPort = new Serial(this, Serial.list()[0], 9600);
  // identify we're connected
  blink();
  // set default background color
  background(200);
} 

// send data to Arduino to blink the led
void blink() {
  delay(2000); // necessary to make sure serial comms is established
  for (int i = 0; i< 5; i++) {
    // 255 is led full on
    myPort.write(255);
    delay(200);
    // 0 is led off
    myPort.write(0);
    delay(200);
  }
}

void draw() {
  // check if data is available and copy the received values to the data array
  if (checkForNewData()) {
    // do something with the data
    background(data[1]/4);
    rect(0, 0, 20, (data[2]-500)*5);
    rect(20, 0, 20, data[0]*200);
  }
}

boolean checkForNewData() {
  // check if data is received
  if (myPort.available() > 0) { 
    // read the line received
    String inString = myPort.readStringUntil(linefeed);
    // could fail....
    if (inString != null) {
      // show (debugging purposes)
      print(inString);
      // received are strings representing integers separated by comma's
      data = int(split(trim(inString), ',')); 
      return true;
    }
  }
  return false;
}

void mouseMoved() {
  myPort.write(mouseX *255/600);
}